+================================================
+                                                
+ simCNC LASER
+                                                
+================================================
+                                                
+ History                                        
+                                                
+ Who      When       What                         
+ ======== ========== ===========================

+ WTrawicki  16/07/2020 Creation

+================================================

+LASER_SUPPORT = "YES"

POST_NAME = "simCNC LASER (inch)(*.nc)"

FILE_EXTENSION = "nc"

UNITS = "INCHES"

SUBSTITUTE = "({)}"

+------------------------------------------------
+    Line terminating characters                 
+------------------------------------------------

LINE_ENDING = "[13][10]"

+------------------------------------------------
+    Block numbering                             
+------------------------------------------------

LINE_NUMBER_START     = 0
LINE_NUMBER_INCREMENT = 1
LINE_NUMBER_MAXIMUM = 999999

+================================================
+                                                
+    Formating for variables                     
+                                                
+================================================

VAR LINE_NUMBER = [N|A|N|1.0]
VAR POWER = [P|A|S|1.0|1.0]
VAR FEED_RATE = [F|C|F|1.1]
VAR X_POSITION = [X|C|X|1.5]
VAR Y_POSITION = [Y|C|Y|1.5]
VAR Z_POSITION = [Z|C|Z|1.5]
VAR ARC_CENTRE_I_INC_POSITION = [I|A|I|1.5]
VAR ARC_CENTRE_J_INC_POSITION = [J|A|J|1.5]
VAR X_HOME_POSITION = [XH|A|X|1.5]
VAR Y_HOME_POSITION = [YH|A|Y|1.5]
VAR Z_HOME_POSITION = [ZH|A|Z|1.5]
VAR SAFE_Z_HEIGHT = [SAFEZ|A|Z|1.5]
VAR DWELL_TIME = [DWELL|A|P|1.2]
+================================================
+                                                
+    Block definitions for toolpath output       
+                                                
+================================================

+---------------------------------------------------
+  Commands output at the start of the file
+---------------------------------------------------

begin HEADER

"%"
"( [TP_FILENAME] )"
"( File created: [DATE] - [TIME] )"
"( Material Size: X= [XLENGTH], Y= [YLENGTH], Z= [ZLENGTH] )"
"( Notes: [FILE_NOTES] )"
"( Toolpaths used in this file: [TOOLPATHS_OUTPUT] )"
"( Tools used in this file: [TOOLS_USED] )"
""
"G17 G20 G40 G49 G80 G90 G94"
+"G91 G28 Z0"
+"G28 X0 Y0"
+"G90"
+""
+"T[T] M06 ( [TOOLNAME] )"
+"G43 H[T]"
"G0 [XH] [YH]"
"G0 [ZH]"
""
"M13 ( Laser power control - enabled / Please contact CS-LAB for details)" 
""
"( Toolpath: [TOOLPATH_NAME] )"
"( Notes: [TOOLPATH_NOTES] )"
""
"[F]"

+---------------------------------------------------
+  Commands output for rapid moves 
+---------------------------------------------------

begin RAPID_MOVE

"G0 [X] [Y] [Z]"

+---------------------------------------------------
+  Commands output for the first feed rate move
+---------------------------------------------------

begin FIRST_FEED_MOVE

"G1 [X] [Y] [Z] [F]"

+---------------------------------------------------
+  Commands output for feed rate moves
+---------------------------------------------------

begin FEED_MOVE

"G1 [X] [Y] [Z]"

+---------------------------------------------------
+  Commands output for the first clockwise arc move
+---------------------------------------------------

begin FIRST_CW_ARC_MOVE

"G2 [X] [Y] [I] [J] [F]"

+---------------------------------------------------
+  Commands output for clockwise arc  move
+---------------------------------------------------

begin CW_ARC_MOVE

"G2 [X] [Y] [I] [J]"

+---------------------------------------------------
+  Commands output for the first counterclockwise arc move
+---------------------------------------------------

begin FIRST_CCW_ARC_MOVE

"G3 [X] [Y] [I] [J] [F]"

+---------------------------------------------------
+  Commands output for counterclockwise arc  move
+---------------------------------------------------

begin CCW_ARC_MOVE

"G3 [X] [Y] [I] [J]"

+---------------------------------------------------
+  Commands output for a new segment - toolpath
+  with same toolnumber but maybe different feedrates
+---------------------------------------------------

begin NEW_SEGMENT

""
"( Toolpath: [TOOLPATH_NAME] )"
"( Notes: [TOOLPATH_NOTES] )"
""
"[F]"

+---------------------------------------------
+  Commands output for a dwell move
+---------------------------------------------

begin DWELL_MOVE

"G04 [DWELL]"

+---------------------------------------------------
+  Commands output when the jet is turned on
+---------------------------------------------------

begin JET_TOOL_ON

"[P]"

+---------------------------------------------------
+  Commands output when the jet is turned off
+---------------------------------------------------

begin JET_TOOL_OFF

"S0"

+---------------------------------------------------
+  Commands output when the jet power is changed
+---------------------------------------------------

begin JET_TOOL_POWER

"[P]"

+---------------------------------------------------
+  Commands output at the end of the file
+---------------------------------------------------

begin FOOTER

""
"M15 (Laser power control - disabled / Please contact CS-LAB for details)" 
""
"G00 [ZH]"
"G00 [XH] [YH]"
+""
+"G91 G28 Z0"
+"G28 X0 Y0"
+"G90"
"M30"
"%"


